#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<cassert>
#include<string>

#include "utils.h"

#include "Refs.h"
#include "CalcEvalScore.h"

using namespace std;

Refs refs;
double nb_r, nb_p;
int L, w;
char refF[STRLEN], sampleToken[STRLEN], statName[STRLEN], scoreF[STRLEN];

char score_file[STRLEN];

int main(int argc, char* argv[]) {
	if (argc != 8 && argc != 10) {
		printf("Usage: calcScore reference_name sample_name nb_r nb_p L w output_name [--score-file score_file]\n");
		exit(-1);
	}

	if (argc == 10) {
	  assert(!strcmp(argv[8], "--score-file"));
	  strcpy(score_file, argv[9]);
	}

	sprintf(refF, "%s.seq", argv[1]);
	refs.loadRefs(refF);

	// extract sampleToken
	string sample_name(argv[2]);
	size_t pos = sample_name.find_last_of('/');
	strcpy(sampleToken, sample_name.substr(pos + 1).c_str());

	sprintf(statName, "%s.stat/%s", argv[2], sampleToken);

	nb_r = atof(argv[3]);
	nb_p = atof(argv[4]);
	L = atoi(argv[5]);
	w = atoi(argv[6]);

	sprintf(scoreF, "%s.score", argv[7]);

	if (argc == 8) {
	  CalcEvalScore ces(refs, nb_r, nb_p, L, w, statName);
	  ces.writeScoresTo(scoreF);
	}
	else {
	  CalcEvalScore ces(refs, nb_r, nb_p, L, w, statName, score_file);
	  ces.writeScoresTo(scoreF);
	}

	return 0;
}
